﻿using Prsi.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.Actions
{
    class CardAction : ICardAction
    {
        public string TextToShow { get; private set; }
        public int CallingID { get; private set; }

        Func<IStack, IPlayer,ICard,bool> _PerformAction;
        ICard _Card;

        public CardAction(string TextToShow) : this(TextToShow,null,-1,null) {}

        public CardAction(string TextToShow, Func<IStack,IPlayer,ICard,bool> Action, int CallingId, ICard Card)
        {
            this._PerformAction = Action;
            this.TextToShow = TextToShow;
            this.CallingID = CallingId;
            _Card = Card;
        }

        public bool Call(IStack Stack,IPlayer Player)
        {
            return _PerformAction(Stack,Player,_Card);
        }

        public bool HaveActionToPerform
        {
            get
            {
                return _PerformAction != null;
            }
        }
    }
}
