﻿using System;
namespace Prsi.Actions
{
    /// <summary>
    /// Class that contains <c>ICardAction</c>s for game
    /// </summary>
    interface IActionContainer
    {
        /// <summary>
        /// Return IDs of all actions. Dont contain ID = -1 (actions with no callback)
        /// </summary>
        int[] AcceptableIDs { get; }

        /// <summary>
        /// Return all actions, included that with no callback
        /// </summary>
        ICardAction[] Actions { get; }

        /// <summary>
        /// Return specific action with ID
        /// </summary>
        /// <param name="ID">ID of action to return</param>
        /// <returns>Return actions specified by ID</returns>
        ICardAction GetActionWithID(int ID);
    }
}
