﻿using Prsi.Entities;
using System;
namespace Prsi.Actions
{
    /// <summary>
    /// Represent class, that will create actions, that can user call
    /// </summary>
    interface IActionFactory
    {
        /// <summary>
        /// Creates actions. Action with no callback will have ID -1. Cant be called, but have text to dscribe them
        /// </summary>
        /// <param name="Stack">Stack of cards</param>
        /// <param name="PlayerCards">Array of cards, which have player in his hand</param>
        /// <returns>Return array of <c>ICardAction</c>, which can user call. Includes also actions with no callback.</returns>
        ICardAction[] CreateActions(IStack Stack, ICard[] PlayerCards);
    }
}
