﻿using Prsi.Entities;
using System;
namespace Prsi.Actions
{
    /// <summary>
    /// Represent action, which can user call
    /// </summary>
    interface ICardAction
    {
        /// <summary>
        /// Call callback of action
        /// </summary>
        /// <param name="Stack">Stack of cards</param>
        /// <param name="Player">Actual player on turn</param>
        /// <returns>Return true, if this palyer win</returns>
        bool Call(IStack Stack, IPlayer Player);

        /// <summary>
        /// Get IDs of all actions, except that with have no callback
        /// </summary>
        int CallingID { get; }

        /// <summary>
        /// Return true, if this action have callback to call
        /// </summary>
        bool HaveActionToPerform { get; }

        /// <summary>
        /// Return text, which will describe action
        /// </summary>
        string TextToShow { get; }
    }
}
