﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.ConsoleOperation
{
    /// <summary>
    /// Class that creates layer over Console
    /// </summary>
    class ConsoleInput : IMyConsole
    {
        /// <summary>
        /// Getter will create line from Console, Setter will Write to console
        /// </summary>
        public string Text
        {
            get
            {
               return Console.ReadLine();
            }
            set
            {
                Console.Write(value);
            }
        }

        /// <summary>
        /// Write line to console
        /// </summary>
        /// <param name="Text">Text to write</param>
        public void WriteLine(string Text)
        {
            Console.WriteLine(Text);
        }

        /// <summary>
        /// Get or set Console's width
        /// </summary>
        public int Width
        {
            get
            {
                return Console.WindowWidth;
            }
            set
            {
                Console.WindowWidth = value;
            }
        }

        /// <summary>
        /// Will clear Console
        /// </summary>
        public void Clear()
        {
            Console.Clear();
        }

        /// <summary>
        /// This function will move ouput to next line
        /// </summary>
        public void Enter()
        {
            Console.WriteLine();
        }
    }
}
