﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prsi.ConsoleOperation
{
    /// <summary>
    /// Represent stream, which will be used for I/O operations
    /// </summary>
    interface IMyConsole
    {
        /// <summary>
        /// Getter will read text from stream, Setter will write text to stream
        /// </summary>
        string Text { get; set; }

        /// <summary>
        /// Get or set width of one line (eg. for formating)
        /// </summary>
        int Width { get; set; }

        /// <summary>
        /// <c>Enter</c> will move ouput to next line
        /// </summary>
        void Enter();

        /// <summary>
        /// Clear output. Output that dont be visible.
        /// </summary>
        void Clear();
    }
}
