﻿using Prsi.Actions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.Entities.CardsStates 
{
    /// <summary>
    /// Represent state of card
    /// </summary>
    interface ICardState : ICardAndCardStateShared
    {
        /// <summary>
        /// Check if second card could be placed over first one
        /// </summary>
        /// <param name="First">Card on which will gave</param>
        /// <param name="Second">Giving card</param>
        /// <returns>Return true if second card could be palced over first, else false</returns>
        bool CanBePlaced(ICard First, ICard Second);

        /// <summary>
        /// ID of this state
        /// </summary>
        CardStatesEnum ID { get; }
    }
}
