﻿using Prsi.Actions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.Entities.CardsStates
{
    class WaitingAceState : BaseCardState
    {
        public WaitingAceState(IConfigurableCard Card) : base(Card) { }

        public override bool CanBePlaced(ICard First, ICard Second)
        {
            return First.Value == Second.Value;
        }

        public override Func<IStack, IPlayer, ICard, bool> ActionToPerform
        {
            get
            {
                return FuncActionNextTurn;
            }
        }

        public override bool CanDrawFromStack
        {
            get { return false; }
        }

        public override void ActionAfterPutedOnStack()
        {
            
        }

        public override bool CanTakePlayerBackToGame
        {
            get { return false; }
        }

        private static bool FuncActionNextTurn(IStack Stack, IPlayer Player, ICard Card)
        {
            Player.PutCard(Card);
            Stack.LastCard.SetDefaultState();
            Stack.PutCard(Card);
            return false;
        }


        public override bool HasSpecialAction
        {
            get { return true; }
        }

        public override ICardAction SpecialAction(int index)
        {
            return new CardAction("Wait turn", Wait,index,_Card);
        }

        private bool Wait(IStack Stack,IPlayer Player,ICard Card)
        {
            _Card.SetState(CardStatesEnum.UsedAceState);
            return false;
        }

        public override CardStatesEnum ID
        {
            get { return CardStatesEnum.WaitingAceState; }
        }
    }
}
