﻿using Prsi.Actions;
using Prsi.Entities.CardsStates;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.Entities
{
    /// <summary>
    /// Represent card, with which could be played
    /// </summary>
    interface ICard : ICardAndCardStateShared
    {
        /// <summary>
        /// Get color of card
        /// </summary>
        CardColor Color { get; }

        /// <summary>
        /// Get value of card
        /// </summary>
        CardValues Value { get; }

        /// <summary>
        /// Check if are this and second card equal
        /// </summary>
        /// <param name="Second">Card to compare</param>
        /// <returns>Return true if are equal, else false</returns>
        bool AreEqual(ICard Second);
        
        /// <summary>
        /// Return card back to default state
        /// </summary>
        void SetDefaultState();

        /// <summary>
        /// Check if Card could be placed over this card
        /// </summary>
        /// <param name="Card">Card to place over this</param>
        /// <returns>Return true if can be placed, else false</returns>
        bool CanBePlaced(ICard Card);      
    }
}
