﻿using Prsi.Entities.CardsStates;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.Entities
{
    /// <summary>
    /// Represent card, that could be more configurable than card in game
    /// </summary>
    interface IConfigurableCard : ICard
    {
        /// <summary>
        /// Set state of card
        /// </summary>
        /// <param name="State">ID of state</param>
        /// <exception>Throw exception if was state with specified ID not found</exception>
        void SetState(CardStatesEnum State);

        /// <summary>
        /// Get or set default state, which will be used
        /// </summary>
        CardStatesEnum DefaultState { get; set; }

        /// <summary>
        /// Add state of card, so it can be used
        /// </summary>
        /// <param name="State">State to add</param>
        void AddState(ICardState State);
    }
}
