﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.Entities
{
    /// <summary>
    /// Represent factory, that creates entities (Cards and Players) to game
    /// </summary>
    interface IEntitiesFactory : IEntitiesContainer
    {
        /// <summary>
        /// Creates players in amount of param
        /// </summary>
        /// <param name="CountOfPlayers">Count of players to create</param>
        /// <returns>Return true if was players created, else false</returns>
        bool CreatePlayers(int CountOfPlayers);

        /// <summary>
        /// Create stack 
        /// </summary>
        /// <param name="UseEnhancedSet">If set to true double stack will be created (with 64 cards)</param>
        /// <returns>Return true if was stack created, else false</returns>
        bool CreateStack(bool UseEnhancedSet);

        /// <summary>
        /// Remove cards from stack and give them to players hand
        /// </summary>
        /// <param name="AmountOfCards">How many cards will each player get</param>
        void GiveCardsToPlayer(int AmountOfCards);
    }
}
