﻿using Prsi.ViewModels.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.Entities
{
    /// <summary>
    /// Interface that represents player in game
    /// </summary>
    interface IPlayer
    {
        /// <summary>
        /// Name of player
        /// </summary>
        string Name { get; }

        /// <summary>
        /// Login player into game
        /// </summary>
        /// <param name="ViewModel">ViewModel throught wich ask for password</param>
        void Login(IPlayerViewModel ViewModel);

        /// <summary>
        /// Takes card and save it to hand
        /// </summary>
        /// <param name="Card">Card to save</param>
        void TakeCard(ICard Card);

        /// <summary>
        /// Remove card from hand 
        /// </summary>
        /// <param name="Card">Which card to remove</param>
        /// <returns>Removed card</returns>
        ICard PutCard(ICard Card);

        /// <summary>
        /// Get count of cards in hand
        /// </summary>
        int CountOfCards { get; }

        /// <summary>
        /// Returns the array of card in hand
        /// </summary>
        // Pozn.: Mela by byt spise metoda, ktera jako parametr prijima pole karet 
        // a grac by teto metode mel karty predat
        ICard[] Cards { get; }
    }
}
