﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.Entities
{
    /// <summary>
    /// Represent card stack in game
    /// </summary>
    interface IStack
    {
        /// <summary>
        /// Return card on the top of stack
        /// </summary>
        ICard LastCard { get; }

        /// <summary>
        /// Draw card from the stack
        /// </summary>
        /// <returns>Returns drawed car</returns>
        ICard DrawCard();

        /// <summary>
        /// Add card to the top of the stack
        /// </summary>
        /// <param name="Card">Card to add</param>
        /// <returns>Return true if was card added, else true</returns>
        bool PutCard(ICard Card);

        /// <summary>
        /// Return true if could be draw card, else true
        /// </summary>
        // eg. because is no card on stack
        bool CanDrawCard { get; }
    }
}
