﻿using Prsi.ViewModels.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.Entities
{
    class Player : IConfigurablePlayer
    {
        private string _Name;
        private string _Password;
        private List<ICard> _CardsInHand;

        public Player(string Name, string Password)
        {
            this._Name = Name;
            this._Password = Password;
            this._CardsInHand = new List<ICard>();
        }

        public string Name
        {
            get { return _Name; }
        }

        public void TakeCard(ICard Card)
        {
            _CardsInHand.Add(Card);
        }

        public void Login(IPlayerViewModel LoginModel)
        {
            while(!CheckPassword(LoginModel.GetPassword(_Name)))
                LoginModel.InvalidPassword();
            LoginModel.ValidPassowrd();
        }


        public bool CheckPassword(string PasswordToCheck)
        {
            return PasswordToCheck == _Password;
        }

        public ICard[] Cards
        {
            get
            {
                return _CardsInHand.ToArray();
            }
        }


        public int CountOfCards
        {
            get { return _CardsInHand.Count; }
        }


        public ICard PutCard(ICard Card)
        {
            int Index=_CardsInHand.IndexOf(Card);
            if(Index<0)
            {
                Exception e = new Exception("Card wasnt fount in player hand");
                e.Data["EndState"] = ProgramsEndStateEnum.CardWasntFoundInPlayerHand;
                throw e;
            }
            ICard CardToReturn=_CardsInHand[Index];
            _CardsInHand.Remove(Card);
            CardToReturn.ActionAfterPutedOnStack();
            return CardToReturn;
        }
    }
}
