﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.Entities
{
    class Stack : IConfigurableStack
    {
        private List<ICard> Cards;

        public Stack(ICard[] Cards)
        {
            this.Cards = new List<ICard>(Cards);
        }

        public void MixCards()
        {
            Random Random=new Random();
            Func<ICard,float> Callback = (x) => {return Random.Next();};
            for (int a = 0; a < 5; a++)
                Cards = Cards.OrderBy(Callback).ToList();
        }

        public ICard LastCard
        {
            get { return Cards.Last(); }
        }

        public ICard DrawCard()
        {
            ICard Card = Cards.First();
            Cards.RemoveAt(0);
            return Card;
        }

        public bool PutCard(ICard Card)
        {
            Cards.Add(Card);
            Card.ActionAfterPutedOnStack();
            return true;
        }

        public int GetCountOfCards
        {
            get { return Cards.Count; }
        }


        public bool CanDrawCard
        {
            get { return Cards.Count > 1; }
        }
    }
}
