﻿using Prsi.ConsoleOperation;
using Prsi.ViewModels;
using Prsi.ViewModels.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi
{
    /// <summary>
    /// Entry point
    /// </summary>
    class Program
    {
        /// <summary>
        /// Entry point of program
        /// </summary>
        static int Main(string[] args)
        {
            IMyConsole Console = new ConsoleInput();

            IViewModel ViewModel = new ConsoleViewModel(Console);
            Prsi prsi = new Prsi(ViewModel);
            try
            {
                return prsi.Run();
            }
            catch(Exception e)
            {
                ViewModel.Exception.ShowException(e);
                return (int)e.Data["EndState"];
            }
        }
    }
}
