﻿using Prsi.Actions;
using Prsi.ConsoleOperation;
using Prsi.ViewModels.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.ViewModels
{
    class ActionViewModel : BaseViewModel, IActionViewModel
    {
        private FromConsoleConverter Converter;

        public ActionViewModel(IMyConsole IO,IOutputFormater Formater) 
            : base(IO,Formater) 
        {
            this.Converter = new FromConsoleConverter(_IO);
        }


        public void DisplayAction(ICardAction[] Actions)
        {
            foreach (ICardAction Action in Actions)
            {
                if (Action.HaveActionToPerform)
                    _IO.Text = _Formater.AlignLeft(string.Format("{0,3}-{1}",Action.CallingID,Action.TextToShow));
                else
                    _IO.Text = _Formater.AlignLeft(string.Format("    {0}", Action.TextToShow));
            }
        }



        public int AskForAction(int[] AcceptedValues)
        {
            return Converter.ConvertInput(int.Parse, "Your choice", _Formater.AlignLeft,
                (number) => { return AcceptedValues.Contains(number); });
        }
    }
}
