﻿using Prsi.ConsoleOperation;
using Prsi.ViewModels.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.ViewModels
{
    class ConfigViewModel : BaseViewModel, IConfigViewModel
    {
        private FromConsoleConverter _Converter;

        private int _CountOfPlayers = 0;
        private bool _EnhancedSet = false;
        private bool _EnhancedSetCalled = false;
        private int _AmountOfCard = 0;

        public ConfigViewModel(IMyConsole IO,IOutputFormater Formater) : base(IO,Formater)
        {
            this._Converter = new FromConsoleConverter(IO);
        }

        private int GetCountOfPlayers()
        {
            return Convert("Number of players 2-6", (number) => { return number > 1 && number < 7; });
        }

        private bool AskIfIsEnhancedSetOfCards()
        {
            _EnhancedSetCalled = true;
            string[] Menu = { "We realized, that you have more than 4 players",
                              "we recommend to use enhanced set of cards with 64 cards",
                              "1 - Yes",
                              "2 - No" };
            foreach (string s in Menu)
                _IO.Text = _Formater.AlignLeft(s);

            int Value = Convert("Use enhanced set", (number) => { return number > 0 && number < 3; });

            switch(Value)
            {
                case 1: return true;
                case 2: return false;
                default: return false;
            }
        }


        private int GetAmountOfCardForEachPlayer()
        {
            return Convert("How many card every player get at start? 3-7", (number) => { return number > 2 && number < 8; });
        }

        private int Convert(string Question,Func<int,bool> Validation)
        {
            return _Converter.ConvertInput(int.Parse, Question, _Formater.AlignLeft, Validation);
        }

        public int CountOfPlayers
        {
            get {
                if (_CountOfPlayers == 0)
                    _CountOfPlayers = GetCountOfPlayers();
                return _CountOfPlayers;
            }
        }

        public bool IsEnhancedSetOfCards
        {
            get 
            {
                if (!_EnhancedSetCalled)
                    _EnhancedSet = AskIfIsEnhancedSetOfCards();
                return _EnhancedSet;
            }
        }

        public int AmountOfCardForEachPlayer
        {
            get
            {
                if (_AmountOfCard == 0)
                    _AmountOfCard = GetAmountOfCardForEachPlayer();
                return _AmountOfCard;
            }
        }
    }
}
