﻿using Prsi.ConsoleOperation;
using Prsi.ViewModels.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.ViewModels
{
    class ConsoleViewModel : BaseViewModel, IViewModel
    {
        IWelcomeByeViewModel _WelcomeByeOutput;
        IConfigViewModel _Configure;
        IFactoryViewModel _Factory;
        IExceptionViewModel _Exception;
        IPlayerViewModel _Player;
        IGameViewModel _Game;
        IActionViewModel _Action;

        public ConsoleViewModel(IMyConsole Console) : base(Console,new OutputFormater(Console))
        {
            if (_Formater == null)
                this._Formater = new OutputFormater(Console);
            this._IO = Console;

            _WelcomeByeOutput = new WelcomeByeMessanger(Console,_Formater.AlignCenter);
            _Configure = new ConfigViewModel(Console,_Formater);
            _Factory = new FactoryViewModel(Console,_Formater);
            _Exception = new ExceptionViewModel(Console,_Formater);
            _Player = new PlayerViewModel(Console,_Formater);
            _Game = new GameViewModel(Console,_Formater);
            _Action = new ActionViewModel(Console,_Formater);
        }

        public IWelcomeByeViewModel WelcomeBye
        {
            get { return _WelcomeByeOutput; }
        }


        public IConfigViewModel Configure
        {
            get { return _Configure; }
        }


        public IFactoryViewModel Factory
        {
            get { return _Factory; }
        }


        public IExceptionViewModel Exception
        {
            get { return _Exception; }
        }


        public IPlayerViewModel Player
        {
            get { return _Player; }
        }


        public IGameViewModel Game
        {
            get { return _Game; }
        }


        public IActionViewModel Action
        {
            get { return _Action; }
        }
    }
}
