﻿using Prsi.ConsoleOperation;
using Prsi.Entities;
using Prsi.ViewModels.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.ViewModels
{
    class FactoryViewModel : BaseViewModel, IFactoryViewModel
    {
        public FactoryViewModel(IMyConsole IO, IOutputFormater Formater)
            : base(IO, Formater) { }

        public IConfigurablePlayer CreatePlayer(int IndexOfPlayer)
        {
            string[] Questions = {string.Format("Choose name of Player {0}: ",IndexOfPlayer),
                                  "Choose password: "};
            string[] Answers = Ask(Questions);
            IConfigurablePlayer Player = new Player(Answers[0],Answers[1]);
            _Formater.Clear();
            return Player;
        }

        private string[] Ask(string[] Questions)
        {
            List<string> Answers = new List<string>();
            foreach(string s in Questions)
            {
                _IO.Text = _Formater.AlignLeft(s,s.Length);
                Answers.Add(_IO.Text);
            }
            return Answers.ToArray();
        }
    }
}
