﻿using Prsi.ConsoleOperation;
using Prsi.Entities;
using Prsi.ViewModels.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.ViewModels
{
    class GameViewModel : BaseViewModel, IGameViewModel
    {
        public GameViewModel(IMyConsole IO,IOutputFormater Formater) 
            : base(IO,Formater) {}

        public void ClearOutput()
        {
            _IO.Clear();
        }


        public void ShowActualPlayer(IPlayer Player)
        {
            string Message = string.Format("Player {0} is on turn. Have {1} cards.",Player.Name,Player.CountOfCards);
            _IO.Enter();
            _IO.Text = _Formater.AlignLeft(Message);
        }


        public void ShowPlayersStats(Queue<IPlayer> Players,IPlayerViewModel PlayerViewModel)
        {
            _IO.Enter();
            _IO.Text = _Formater.AlignLeft("States of other players");
            foreach(IPlayer Player in Players)
                _IO.Text = _Formater.AlignLeft(PlayerViewModel.GetInfo(Player));
        }

        public void ShowPlayQueue(Queue<IPlayer> Players)
        {
            _IO.Enter();
            StringBuilder Builder = new StringBuilder();
            Builder.Append("Players in queue: you");
            foreach (IPlayer Player in Players)
                Builder.Append(" > ").Append(Player.Name);

            _IO.Text = _Formater.AlignLeft(Builder.ToString());
        }


        public void ShowCardOnStack(ICard Card)
        {
            StringBuilder Builder = new StringBuilder();
            Builder.Append("Last card on stack: ");
            Builder.Append((char)Card.Color).Append((char)Card.Value);

            _IO.Text = _Formater.AlignLeft(Builder.ToString());
        }


        public void ShowWinners(IPlayer[] Players)
        {
            StringBuilder Builder = new StringBuilder();
            _IO.Clear();
            Builder.Append(_Formater.AlignCenter("Winners are"));
            for (int a = 0; a < Players.Length; a++)
                Builder.Append(_Formater.AlignCenter(string.Format("{0,2}. - {1}", a+1, Players[a].Name)));

            _IO.Text = Builder.ToString();
        }
    }
}
