﻿using Prsi.ConsoleOperation;
using Prsi.ViewModels.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi.ViewModels
{
    class WelcomeByeMessanger : IWelcomeByeViewModel
    {
        private class Message
        {
            public Message() : this(null,' ') {}
            public Message(string Text, char FillSymbol = ' ')
            {
                this.Text = Text;
                this.FillSymbol = FillSymbol;
            }
            public string Text { get; set; }
            public char FillSymbol { get; set; }
        }

        #region IWelcomeByeViewModel implementation
        public void Welcome()
        {
            Write(WelcomeMessages);
        }

        public void Bye()
        {
            Write(GoodbyeMessages);

#if DEBUG
            Console.ReadKey();
#endif
        }
        #endregion


        private Message[] WelcomeMessages = { new Message("Prší"), 
                                              new Message("Made by Patrik Valkovic"), 
                                              new Message("v1 2015"),
                                              new Message("",'#') };
        private Message[] GoodbyeMessages = { new Message("",'#'),
                                              new Message("Thank you for using this program") };

        private IMyConsole Output;
        private Func<string, char, string> Formater;

        public WelcomeByeMessanger(IMyConsole Output,Func<string, char, string> Formater)
        {
            this.Formater = Formater;
            this.Output = Output;
        }

        private void Write(Message[] Messages)
        {
            foreach (Message Message in Messages)
                Output.Text = Formater(Message.Text,Message.FillSymbol);
        }
    }
}
