﻿using Prsi.ConsoleOperation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PrsiTests.ProgramAbstraction.ConsoleManipulation
{
    class OutputFormaterAbstract : IOutputFormater
    {
        private List<string> NormalOutput = new List<string>();
        private OutputFormater Formater;

        public OutputFormaterAbstract(IMyConsole Console)
        {
            this.Formater = new OutputFormater(Console);
        }

        #region InterfaceImplementation
        public string AlignCenter(string Text)
        {
            NormalOutput.Add(Formater.AlignCenter(Text));
            return Text;
        }

        public string AlignCenter(string Text, char FillSymbol)
        {
            NormalOutput.Add(Formater.AlignCenter(Text,FillSymbol));
            return Text;
        }

        public string AlignCenter(string Text, int Width)
        {
            NormalOutput.Add(Formater.AlignCenter(Text,Width));
            return Text;
        }

        public string AlignCenter(string Text, int Width, char FillingSymbol)
        {
            NormalOutput.Add(Formater.AlignCenter(Text,Width,FillingSymbol));
            return Text;
        }

        public string AlignLeft(string Text)
        {
            NormalOutput.Add(Formater.AlignLeft(Text));
            return Text;
        }

        public string AlignLeft(string Text, char FillSymbol)
        {
            NormalOutput.Add(Formater.AlignLeft(Text,FillSymbol));
            return Text;
        }

        public string AlignLeft(string Text, int Width)
        {
            NormalOutput.Add(Formater.AlignLeft(Text,Width));
            return Text;
        }

        public string AlignLeft(string Text, int Width, char FillingSymbol)
        {
            NormalOutput.Add(Formater.AlignLeft(Text,Width,FillingSymbol));
            return Text;
        }

        public string AlignRight(string Text)
        {
            NormalOutput.Add(Formater.AlignRight(Text));
            return Text;
        }

        public string AlignRight(string Text, char FillSymbol)
        {
            NormalOutput.Add(Formater.AlignRight(Text,FillSymbol));
            return Text;
        }

        public string AlignRight(string Text, int Width)
        {
            NormalOutput.Add(Formater.AlignRight(Text,Width));
            return Text;
        }

        public string AlignRight(string Text, int Width, char FillingSymbol)
        {
            NormalOutput.Add(Formater.AlignRight(Text,Width,FillingSymbol));
            return Text;
        }
        #endregion


        public void Clear()
        {
            NormalOutput.Add("Window was cleare");
        }
    }
}
