﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Prsi.ViewModels;
using Prsi.ViewModels.Interfaces;
using Prsi.ConsoleOperation;
using PrsiTests.ProgramAbstraction.ConsoleManipulation;

namespace PrsiTests
{
    [TestClass]
    public class ExceptionViewModelTest
    {
        [TestMethod]
        public void TestExceptionShow()
        {
            InputAbstract Console=new InputAbstract();
            Console.Width = 30;
            Console.AddTextToReturn("x");
            IOutputFormater Formater = new OutputFormaterAbstract(Console);
            IExceptionViewModel ViewModel = new ExceptionViewModel(Console,Formater);

            Exception e = new Exception("Exception message");
            e.Data["EndState"] = 5;
            ViewModel.ShowException(e);

            Assert.AreEqual("Error occurs in program and will be exited",Console.GetOutput(0));
            Assert.AreEqual("Reason of error", Console.GetOutput(1));
            Assert.AreEqual("Exception message", Console.GetOutput(2));
            Assert.AreEqual("Program ended with state 5", Console.GetOutput(3));
            Assert.AreEqual("Press any key to exit", Console.GetOutput(4));
        }

    }
}
