﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Mau_Mau
{
    class Game
    {
        Random rnd = new Random();
        ControlOfGame cof;

        int countOfPlayer;
        Player[] players;

        DeckOfCards doc;
        DiscardDeck dd;
        Rules rules;

        string cardUpDeck;
        public static int playerOnTurn;
        public static bool seven = false;
        public static int countOfTakenCards = 0;

        public Game()
        {
            Console.WriteLine("Vítej ve hře Prší");
            Console.WriteLine("=================");

            PrepareGame();

            ChooseStartingPlayer();

            ProgressOfGame();

        }

        public void PrintSituationOfGame()    // Výpis průběhu hry
        {
            Console.WriteLine("Stav karet ostatních hráčů: ");

            for (int i = 0; i < players.Length; i++)
            {

                if (!players[i].name.Equals(players[playerOnTurn].name))
                {
                    Console.WriteLine(players[i].name + ": " + players[i].cards.Count);
                }
            }

            Console.WriteLine();
            Console.WriteLine("Hraje: " + players[playerOnTurn].name);
            Console.Write("Následuje: ");

            int index = playerOnTurn + 1;
            for (int i = index; i < players.Length; i++)
            {
                if (i == players.Length - 1)
                {
                    Console.Write(" > " + players[i].name);
                    i = -1;
                }
                else if (i == playerOnTurn)
                {
                    Console.Write(" > " + players[i].name);
                    break;

                }
                else
                {
                    Console.Write(" > " + players[i].name);
                }

            }

            Console.WriteLine();
            Console.WriteLine();
            Console.WriteLine("Přikládáš na: " + dd.cards[dd.cards.Count - 1]);
            Console.WriteLine();
            Console.WriteLine("Možnosti tahu: ");
            if (seven)
            {
                Console.WriteLine("(Můžeš pouze položit další sedmičku nebo si líznout karty ( " + countOfTakenCards + " ))");
            }

            for (int i = 0; i < players[playerOnTurn].cards.Count + 1; i++)
            {
                if (i == 0)
                {
                    Console.WriteLine(i + ") líznout si");
                }
                else
                {
                    Console.WriteLine(i + ") " + players[playerOnTurn].cards[i - 1]);
                }

            }
            Console.WriteLine("Tvá volba [0 - " + (players[playerOnTurn].cards.Count) + "]");

        }

        public void ProgressOfGame()     // Průběh hry
        {

            while (cof.HaveAllPlayersCards(players))
            {
                PrintSituationOfGame();
                int choose = int.Parse(Console.ReadLine());

        

                while (!cof.RightChooseOfCard(choose, players[playerOnTurn].cards.Count + 1))
                {
                    choose = int.Parse(Console.ReadLine());
                }

                if (!seven)
                {
                    if (choose == 0)
                    {
                        players[playerOnTurn].TakeACard(players, seven, playerOnTurn);
                    }
                    else
                    {
                        players[playerOnTurn].PutACard(choose, players, seven ,playerOnTurn);

                    }
                }
                else
                {
                    // Pokud je po sobě zahraná karta 7, provede se tento odstavec
                    players[playerOnTurn].PlayWithSeven(choose, players, seven, playerOnTurn);
                    
                }

            }

            Console.WriteLine(players[playerOnTurn].name + " vyhrál!!");

            if (players.Length != 2)  // Konec aplikace pro více než dva hráče
            {
                if (cof.ContinueInGame(players))   
                {
                    players = cof.RemoveWinnerPlayer(players);

                    countOfPlayer--;

                    Console.Clear();

                    ProgressOfGame();
                }
                else
                {
                    System.Environment.Exit(1);
                }
            }
            else
            {
                cof.EndOfApplication(players);  // Konec aplikace pro dva hráče
            }

        }


        public void ChooseStartingPlayer()   // Rozdají se karty a zamíchají se
        {
            playerOnTurn = rnd.Next(0, players.Length - 1);
            Console.WriteLine("Zacina " + players[playerOnTurn].name + ", mícha karty a rozdá každému 4 karty.");

            doc.MixCards();  // Zamíchání karet

            for (int i = 0; i < 4; i++)
            {
                for (int j = 0; j < players.Length; j++)
                {

                    players[j].cards.Add(doc.cards[0]);
                    doc.cards.RemoveAt(0);

                }
            }

            Console.WriteLine(players[playerOnTurn].name + " vybírá vrchní kartu: ");
            cardUpDeck = (string)doc.cards[0];
            doc.cards.RemoveAt(0);
            dd.cards.Add(cardUpDeck);

            Console.WriteLine("Napiš start pro začátek hry: ");
            while (!Console.ReadLine().Equals("start"))
            {
                Console.WriteLine("Špatné slovo!!!");
            }
            Console.Clear();

        }

        public void PrepareGame()   // Připraví hru, zadá se počet a jména hráčů
        {
            Console.WriteLine("Zadej počet hráčů:");
            string line = Console.ReadLine();

            doc = new DeckOfCards();  // Balíček karet
            dd = new DiscardDeck();   // Odkládací balíček zahraných karet
            rules = new Rules();     // Pravidla
            cof = new ControlOfGame(); // Výjimky

            while (!cof.IsNumber(line) || !cof.TooLowerPlayers(line))
            {
                line = Console.ReadLine();

            }

            this.countOfPlayer = int.Parse(line);

            players = new Player[this.countOfPlayer];

            Console.WriteLine("Zadej jména hráčů:");
            for (int i = 0; i < countOfPlayer; i++)
            {
                players[i] = new Player(Console.ReadLine(), doc, dd, rules, cof);

            }

            Console.Clear();

        }


    }
}
