﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Mau_Mau
{
    class Player: PlayerInterface
    {
        // Hráč

        public string name;  
        public ArrayList cards = new ArrayList();

        DeckOfCards doc;
        DiscardDeck dd;
        Rules rules;
        ControlOfGame cof;

        public static string color = " ";

        public Player(string name, DeckOfCards doc, DiscardDeck dd, Rules rules, ControlOfGame cof) {
            this.name = name;
            this.doc = doc;
            this.dd = dd;
            this.rules = rules;
            this.cof = cof;
        }

        public void TakeACard(Player[] players, bool seven, int playerOnTurn)     // Líznutí
        {

            cards.Add(doc.cards[0]);
            doc.cards.RemoveAt(0);

            if (rules.IsEmptyDeckOfCards(doc.cards))  // Zkontroluje, jestli je balíček prázdný, pokud ano, překopíruje odkládací balíček na balíček na líznutí
            {
                for (int i = 0; i < dd.cards.Count; i++)
                {
                    doc.cards.Add(dd.cards[i]);
                }
                dd.cards.Clear();
                dd.cards.Add(doc.cards[doc.cards.Count - 1]);
            }

            if (!seven)   // Pokud protihráč hrál sedmičkou, kontroluje se, jestli si líznul nebo ne
            {
                Game.playerOnTurn = rules.NextPlayer(playerOnTurn, players, "none");
            }
            else
            {
                Game.countOfTakenCards--;
                if (Game.countOfTakenCards == 0)
                {
                    Game.seven = false;
                }
            }

            Console.Clear();
        }


        public void PutACard(int choosen, Player[] players, bool seven,  int playerOnTurn)      // Hraje kartu
        {
            int choose = choosen;
            string card = (string)cards[choose - 1];

            while (!rules.GiveRightCard((string)dd.cards[dd.cards.Count - 1], card, color))  // Kontrola, jestli hráč hrál správnou kartou
            {
                choose = int.Parse(Console.ReadLine());

                while (!cof.RightChooseOfCard(choose, cards.Count + 1))  // Kontrola, jestli hráč hraje ze svého balíčku
                {
                    choose = int.Parse(Console.ReadLine());
                }

                if (choose != 0)
                {
                    card = (string)cards[choose - 1];
                }
                else
                {
                    TakeACard(players, seven, playerOnTurn);
                    break;
                }

            }
           

            if (choose != 0)
            {
                if (!color.Equals(" "))
                {
                    color = " ";
                    dd.cards.RemoveAt(dd.cards.Count - 1); // Odebere barvu z balíčku, protže to není karta, ale je s ní tak zacházeno
                }

                if (rules.MustTakeTwoCards(choose, players, playerOnTurn))  // Pravidlo sedmičky
                {
                    Game.seven = true;
                    Game.countOfTakenCards += 2;
                }

                players[playerOnTurn].cards.RemoveAt(choose - 1); // Odebere zahranou kartu z karet hráče

                Console.Clear();

                color = rules.ChooseColor(card, cof);   // Pokud hráč hraje kartou Q, mění barvu

                Game.playerOnTurn = rules.NextPlayer(playerOnTurn, players, card); // Změna hráče

                dd.cards.Add(card); // přidá kartu do odkládacího balíčku

                if (!color.Equals(" "))
                {
                    dd.cards.Add(color);  // Přídá barvu do balíčku
                }
            }
        }


        public void PlayWithSeven(int choosen, Player[] players, bool seven, int playerOnTurn)  // Pokud je po sobě zahraná karta 7, provede se tento odstavec
        {
            int choose = choosen;
            while (choose != 0 && !rules.MustTakeTwoCards(choose, players, playerOnTurn))
            {
                Console.WriteLine("Nemůžeš zvolit jinou možnost!!!");
                choose = int.Parse(Console.ReadLine());
            }

            if (choose == 0)
            {
                TakeACard(players, seven, playerOnTurn);
            }
            else
            {
                string card = (string)cards[choose - 1];

                cards.RemoveAt(choose - 1);

                Console.Clear();

                if (!color.Equals(" "))
                {
                    color = " ";
                    dd.cards.RemoveAt(dd.cards.Count - 1);
                }

                Game.playerOnTurn = rules.NextPlayer(playerOnTurn, players, card);

                Game.countOfTakenCards += 2;

                dd.cards.Add(card);

            }
        }
    }


}
