﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi
{
    class Balicek
    {
        private Lobby lobby;

        private List<Karta> karty, puvodniKarty; // balíček
        public int dostupnychKaret = 0;
        private Random rand;


        public Karta vrchniKarta; // karta na vrchu

        public Balicek(Lobby lobby)
        {
            this.lobby = lobby;
            rand = new Random();
            karty = new List<Karta>(); // Vytvoří seznam karet, které se budou používat ve hře
            puvodniKarty = new List<Karta>(); // a seznam, který se bude používat pro obnovení
            #region vypln seznamu s kartama
            for (byte i = (byte)(Nastaveni.druhKaret*5); i < 13; i++) // Typ karty
            {
                for (byte j = 0; j < 4; j++) // Typ symbolu
                {
                    puvodniKarty.Add(new Karta(i, j));
                }
            }
            #endregion
            karty.Clear();
            karty.AddRange(puvodniKarty);
            vrchniKarta = LizniKartu(); // Lízne kartu, která bude na vrchu jako první
            dostupnychKaret = 52 - Nastaveni.druhKaret * 20;
        }

        public void Reset()
        {
            dostupnychKaret = 52 - Nastaveni.druhKaret * 20;
            karty.Clear();
            karty.AddRange(puvodniKarty); // Zaplní karty původním seznamem s kartama
            VymazKartyHracu(); // a následně z něj odstraní karty, které jsou již u hráčů
            karty.Remove(vrchniKarta); // a nakonec se zbaví karty, která je právě vyložená, protože ta tam musí zůstat
        }

        public Karta LizniKartu() // ano, tato funkce bude lízat karty
        {
            try {
                Karta karta = karty[rand.Next(karty.Count)]; // Vybere další možnou kartu
                karty.Remove(karta); // Odstraní ji to z karek, které lze líznout
                if (karty.Count == 0) Reset(); // Když je těch karet 0, tak to vrátí karty z hromádky do balíčku
                dostupnychKaret--;
                return karta;
            }catch(Exception ex){lobby.Remiza();}
            return null; // Tento případ nemůže nastat
        }

        public Karta LizniKartu(Hrac hrac)
        {
            Karta karta = LizniKartu(); // lízne to kartu
            hrac.PridejKartu(karta); // a dá jí to hráči přímo do ruky
            return karta; // tenhle return využiju snad jen o prohlášení, že jsem si líznul kartu :/
        }

        public void RozdejKartyHraci(Hrac hrac) // a tato je bude rozdávat hráčům 
        {
            for (int i = 0; i < Nastaveni.zacatekKaret; i++){ // lízne 4, případně nastavitelně karet (no co, vy jste nikdy nehráli s více či méně kartami?)
                LizniKartu(hrac);
            }
        }

        public void VymazKartyHracu() // Vymaže karty, co mají u sebe hráči
        {
            foreach (Hrac hrac in lobby.hraci)
            {
                karty = karty.Except(hrac.karty).ToList(); // Pěkne jeden seznam po jednom to odstraní z toho hlavního
                dostupnychKaret -= hrac.karty.Count;
            }
        }

        public bool PorovnejKarty(Karta karta) // Porovná tvojí kartu s kartou, co je na vrchu
        {
            if ((karta.mod.lzePresCokoliv && !vrchniKarta.mod.nelzePrebitJinou) || // Zkontroluje případ šotka a sedmi nebo esa
                karta.hodnota == vrchniKarta.hodnota || // Porovná hodnotu karty
                ((vrchniKarta.mod.zmenSymbol == karta.symbol) || (karta.symbol == vrchniKarta.symbol && vrchniKarta.mod.zmenSymbol == -1)) && !vrchniKarta.mod.nelzePrebitJinou) // Zkontroluje, jak zapadá symbol
                return true;
            return false;
        }
    }
}
