﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prsi
{
    /// <summary>
    /// This singleton is helper for asking user (with console).
    /// </summary>
    public class Questions
    {
        private int min;
        private int max;

        private static Questions instance = null;
        public static Questions GetInstance()
        {
            if (instance == null)
            {
                instance = new Questions();
            }
            return instance;
        }

        private Questions()
        {
            min = 0;
            max = 0;
        }

        public int AnswerInRange(string question, int Min, int Max)
        {
            min = Min;
            max = Max;
            int count = -1;
            do
            {
                Console.Write(question);
                try
                {
                    count = Convert.ToInt32(Console.ReadLine());

                    if (IsOutOfRange(count))
                        Console.WriteLine("Zadané číslo není v rozsahu!\n");
                }
                catch (Exception e)
                {
                    Console.WriteLine("Toto není celé číslo!\n");
                }

            } while (IsOutOfRange(count));

            //Console.Clear();
            return count;
        }

        public List<Player> CreatePlayers(int countOfPlayers)
        {
            List<Player> players = new List<Player>(countOfPlayers);

            Console.WriteLine("Zadej jména všech hráčů:");
            for (int i = 0; i < countOfPlayers; i++)
            {
                string name = Console.ReadLine();
                players.Add(new Player(name));
            }

            return players;
        }

        private bool IsOutOfRange(int number)
        {
            return number < min || number > max;
        }
    }
}
