﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Prsi
{
    class Lobby
    {
        public List<Hrac> hraci, vyherci;
        private int tahHrace = 0;
        public static int aktualniNasobic = 1;

        private Balicek balicek;

        public Lobby()
        {
            NastaveniPodleHrace();
            balicek = new Balicek(this);
            Random rand = new Random();
            VyplnLidi(); // vypln seznam s lidma
            tahHrace = rand.Next(hraci.Count);
            Smycka();
        }

        private void NastaveniPodleHrace()
        {
            Console.WriteLine("Nějaké vysvětlivky\n-----------");
            Console.WriteLine(" -Pokud v balíčku zbývá už jen 8 karet, tak nelze lízat \n (rezerva kvůli možnosti 4 sedem za sebou)");
            Console.WriteLine(" -Max limit hráčů je: 5 (zase kvůli dostatku karet na hru)\n");
            Console.WriteLine("Nastavení hry\n-----------");
            Console.WriteLine("Karet existují dva druhy:");
            Console.WriteLine("0)\t52 karet\t2, 3, 4, 5, 6, 7, 8, 9, ...");
            Console.WriteLine("1)\t32 karet\t7, 8, 9, 10, spodek, šotek, ...");
            Mezera();
            Nastaveni.druhKaret = (byte)Program.ZiskejVstup("Vyberte možnost [0-1]: ", 1);
            Mezera();
            #region možnost dalšiho nastaveni
            /*Console.WriteLine("Jak zapisovat symboly karet:");
            Console.WriteLine("0)\tznakama");
            Console.WriteLine("1)\tněmecky");
            Console.WriteLine("2)\titalsko-španělsky");
            Mezera();
            Nastaveni.rezimSymbol = (byte)Program.ZiskejVstup("Vyberte možnost [0-2]: ", 2);
            Mezera();
            Console.WriteLine("Jak zapisovat druh karty:");
            Console.WriteLine("0)\tčíselně\t\t7, 8, 9, 10, spodek, ...");
            Console.WriteLine("1)\tpísemně\t\tsedma, osma, devítka, ...");
            Mezera();
            Nastaveni.rezimKaret = (byte)Program.ZiskejVstup("Vyberte možnost [0-1]: ", 2);*/
            #endregion
            Console.Clear();
        }

        private void VyplnLidi()
        {
            hraci = new List<Hrac>(); // Vytvoří seznam s hráčema
            vyherci = new List<Hrac>(); // Seznam s lidma, co již dohráli
            while (true)
            {
                if (hraci.Count > 1) Console.WriteLine("(Pokud hráčů víc nebude, jméno již nevyplňuj)"); // Zeptá se, jestli počet hráčů stačí
                if (hraci.Count == Nastaveni.maxHracu) // Hráčů nesmí být hodně
                {
                    Console.WriteLine("Hráčů už je dost, hra by pak nebyla záživná a nebyl by dostatek karet."); 
                    break;
                }
                Console.WriteLine("Napiš jméno hráče:");
                string jmeno = Console.ReadLine(); // Hráč napíše jméno
                Console.WriteLine(""); // Mezera lepší zorientování mezi jednotlivými uživateli
                if (jmeno.Replace("\t", "").Replace(" ", "").Equals("")) // Zjistí, jestli jméno není prázné, nebo tvořené whitespacem, jinak to přeskočí
                {
                    break;
                }
                else // Pokud je vše vpořádku, přidá to hráče s následujícím jménem ...
                {
                    Hrac hrac = new Hrac(jmeno);
                    balicek.RozdejKartyHraci(hrac); // ještě mu to dá karty, proč ne, žejo?
                    hraci.Add(hrac);
                }
            }
            if (hraci.Count < 2) // Vypne hru, pokuď hráči nejsou dva, tak to nemá cenu
            {
                Console.WriteLine("Je tu příliš málo hráčů.");
                Console.WriteLine("Stiskni jakoukoliv klávesu k ukončení ...");
                Console.Read();
                System.Environment.Exit(0);
            }
        }

        private void VypiseStavKaretKrome(Hrac hrac) // Vypíše seznam s hráčema, kromě toho uvedeného v argumentu
        {
            Console.WriteLine("Stav karet ostatních hráčů:");
            foreach (Hrac hrac2 in hraci)
            {
                if (hrac2 != hrac) Console.WriteLine("{0}: {1}", hrac2.jmeno, hrac2.karty.Count);
            }
        }

        private void ZobrazStavPoziceHracu(Hrac hrac) // Zobrazí aktuálního hráče a pořadí dalších hráčů
        {
            Console.Write("Hraje: ");
            Console.ForegroundColor = ConsoleColor.Blue;
            NapsatBarevne(hrac.jmeno + "\n", ConsoleColor.Cyan); // Výrazně to napíše jméno hráče
            Console.Write("Následuje: ");
            for (int i = tahHrace + 1; i < tahHrace + hraci.Count; i++) // Vypíše následující hráče posunuté o aktuálního hráče
            {
                Console.Write("{0} > ", hraci[i%hraci.Count].jmeno);
            }
            Console.WriteLine(hrac.jmeno); // A nakonec jméno aktuálního hráče, který má zároveň funkci new linu
        }

        private void ZobraziAktualniKartu()
        {
            Console.Write("Přikládáš na: ");
            NapsatBarevne(balicek.vrchniKarta.oznaceni + "\n", ConsoleColor.DarkCyan); // Krásně barevně napíše, jaká karta se právě hraje
            NapsatBarevne(balicek.vrchniKarta.mod.text + "\n", ConsoleColor.Red);
        }

        private void MoznostiTahu(Hrac hrac) // Tato metoda je největší a dá se v ní jednoduše ztratit
        {
            bool preskocit = balicek.vrchniKarta.mod.premeniLizani;
            if (balicek.dostupnychKaret <= 8) { balicek.Reset(); if(aktualniNasobic==1) preskocit = true; }
            Console.WriteLine("Možnosti tahu:");
            if (preskocit)
                Console.WriteLine("0)\tpočkat si");
            else
                Console.WriteLine("0)\tlíznout si");
            // VYPÍŠE SEZNAM MOŽNOSTÍ A ZAPAMATUJE SI JE DO LISTU moznosti
            List<Karta> moznosti = new List<Karta>();
            for (int i = 0, j = 0; i < hrac.karty.Count; i++) // j == číslo karty, která již lze položit na tu, co je nahoře
            {
                Karta karta = hrac.karty[i];
                if (balicek.PorovnejKarty(karta)) // Pokuď lze položit, na tu kartu, tak to tam před to napíše číslo možnosti
                {
                    moznosti.Add(karta); // Přidá se to do možností
                    Console.Write("{0})", ++j); 
                }
                Console.WriteLine("\t{0}", karta.oznaceni);
            }

            // A teďka konečně přichází hráčův vstup
            string max = (moznosti.Count > 0 ? "-" + moznosti.Count : ""); // maximální hodnota, pomocí ternárního operátoru rozhoduje, jestli to tam má bejt vůbec napsané ...
            int vstup = Program.ZiskejVstup(String.Format("Tvá volba [0{0}]: ", max), moznosti.Count); // bude nahrazeno vstupem od hráče
            Mezera();
            if (vstup == 0) // znamená, že si bude lízat
            {
                if (!preskocit)
                for (int i = 0; i < aktualniNasobic; i++) // Lízne karty; Většinou 1, ale někdy může i více ;)
                {
                    Karta lizlaKarta = balicek.LizniKartu(hrac);
                    Console.WriteLine("Líznul/a sis kartu: {0}", lizlaKarta.oznaceni);
                    lizlaKarta.mod.PriLiznuti();
                }
                balicek.vrchniKarta.mod.PriLiznutiDalsi();
            }
            else // bude odehrávat kartu
            {
                Karta vybranaKarta = moznosti[vstup - 1];
                balicek.vrchniKarta = vybranaKarta; // položí tu kartu na vrch
                hrac.karty.Remove(vybranaKarta); // Samozdřejmě ji odstraní z ruky 
                Console.WriteLine("Vyložil/a jsi kartu: {0}", vybranaKarta.oznaceni);
                vybranaKarta.mod.PriVylozeni(); // Vyvolá metodu "Při Vyložení"
            }
        }

        private void ZkontrolujeStavHrace(Hrac hrac) // Zdali mu došli karty a tudíž vyhrál
        {
            if (hrac.karty.Count == 0)
            {
                hraci.Remove(hrac);
                vyherci.Add(hrac);
                Console.WriteLine("Již jsi zkončil! Jsi na {0}. místě ...", vyherci.Count);
            }
            if (hraci.Count == 1)
            {
                vyherci.Add(hraci[0]);
                VyhlaseniVitezu();
            }
        }
        
        private void Predmluva(Hrac hrac) // Takový ty slova, aby ostatní nevejraly na tvoje karty
        {
            Console.Clear();
            Console.WriteLine("\nPrávě hraje: {0}", hrac.jmeno);
            Console.WriteLine("Všichni ostatní odklonit zrak!!");
            Console.ReadLine();
        }

        public void Remiza() // Ošetření pro vyjímku, která nemůže nastat, ale jistota je jistota
        {
            Console.Clear();
            Console.WriteLine("------------------------------");
            Console.WriteLine("----    Nastala Remíza    ----");
            Console.WriteLine("------------------------------");
            Console.WriteLine("----  Zřejmě došli karty  ----");
            Console.WriteLine("------------------------------");
            Console.WriteLine("-- Karty se musejí vykládat --");
            Console.WriteLine("------------------------------");
            Program.Konec();
        }

        public void VyhlaseniVitezu()
        {
            Console.Clear();
            Console.WriteLine("\nSeznam vítězů");
            Console.WriteLine("-------------");
            int i = 0;
            foreach (Hrac hrac in vyherci)
            {
                Console.WriteLine("{0}\t{1}", ++i, hrac.jmeno);
                Console.WriteLine("-------------");
            }
            Program.Konec();
        }

        private void Mezera() // Mezera, tím jsem myslel nový řádek. Snad to všichni chápou ...
        {
            Console.WriteLine();
        }

        private void NapsatBarevne(String text, ConsoleColor barva)
        {
            Console.ForegroundColor = barva;
            Console.Write(text);
            Console.ResetColor();
        }

        private void Smycka()
        {
            while (true)
            {
                if (++tahHrace == hraci.Count) tahHrace = 0; // Zkontroluje, zdali to moc nepretahuje, jinak to vrati k prvnimu
                Hrac hracTahu = hraci[tahHrace]; // Aktuální hráč
                Predmluva(hracTahu); // Nečučte na MOJE KARTY!!!
                Console.Clear(); // Jako první vymázne konzolu
                VypiseStavKaretKrome(hracTahu); // Vypíše stav karet všech hráčů, kromě toho, co hraje teďka
                Mezera();
                ZobrazStavPoziceHracu(hracTahu); // Zobrazí pořadí hráčů
                Mezera();
                ZobraziAktualniKartu(); // Zobrazí kartu, která je na vrchu
                Mezera();
                MoznostiTahu(hracTahu); // Výpis možností
                ZkontrolujeStavHrace(hracTahu);
                Console.WriteLine("Pokračuje další hráč ... ");
                Console.ReadLine();
            }
        }
    }
}
