﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prsi
{
    /// <summary>
    /// This is specific color for each card.
    /// </summary>
    public enum COLOR
    {
        SRDCE = 3,
        KARY,
        PIKY,
        LISTY
    }
    
    /// <summary>
    /// This class represent card, which has a value and a color.
    /// </summary>
    public class Card
    {
        private string value;
        public string Value {  get { return value; } }

        private COLOR color;
        public COLOR Color {  get { return color; } }

        public Card(string value, COLOR color)
        {
            this.value = value;
            this.color = color;
        }

        public override string ToString()
        {
            return (char)color + value;
        }

        public bool Equals(Card card)
        {
            return card.Value == value && card.Color == color;
        }
    }
}
