﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prsi
{
    /// <summary>
    /// This class inherits from Deck. This is special deck for played cards.
    /// </summary>
    public class PlayedCards : Deck
    {
        private const string VALUE_OF_EMPTY_CARD = " ";

        public PlayedCards()
        {
            cards = new List<Card>();
        }

        public void AddCard(Card card)
        {
            cards.Add(card);
        }

        public override Card GetTopCardFromDeck()
        {
            return cards.Last();
        }

        public List<Card> UsePlayedCardsLikeNewDeck()
        {
            List<Card> newDeck = new List<Card>();

            for (int i = 0; i < cards.Count() - 1; i++)
                if (cards[i].Value != VALUE_OF_EMPTY_CARD)
                    newDeck.Add(cards[i]);

            Card lastAddedCart = GetTopCardFromDeck();
            cards.RemoveRange(0, cards.Count - 1);
            newDeck = ShuffleDeck(newDeck);

            return newDeck;
        }
    }
}
