﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Prsi
{
    /// <summary>
    /// This class represent player, who has a name and cards in "his/her hand".
    /// </summary>
    public class Player : IPlayer
    {
        private List<Card> hand;
        public List<Card> Hand { get { return hand; } }

        private string name;
        public string Name { get { return name; } }

        public Player(string name)
        {
            this.name = name;

            hand = new List<Card>();
        }

        public bool Play(Card playedCard)
        {
            foreach (Card card in hand)
            {
                if (card.Equals(playedCard))
                {
                    hand.Remove(playedCard);
                    return true;
                }
            }
            return false;
        }

        public virtual int PlaySpecificStrategi(int countOfValideCards, int min)
        {
            if (countOfValideCards > 0)
                return Questions.GetInstance().AnswerInRange("Tvá volba [" + min + "-" + countOfValideCards + "] ", min, countOfValideCards);
            return Questions.GetInstance().AnswerInRange("Tvá volba [" + min + "] ", min, countOfValideCards);
        }

        public int CountOfCards()
        {
            return hand.Count();
        }

        public void AddCard(Card card)
        {
            hand.Add(card);
        }

        public void AddCards(List<Card> cards)
        {
            hand.AddRange(cards);
        }
    }
}
